import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import controlP5.*; 
import peasy.test.*; 
import peasy.org.apache.commons.math.*; 
import peasy.*; 
import peasy.org.apache.commons.math.geometry.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class hw3_3d extends PApplet {

/*  Homework 3: 3d
    Kurt Kaminski
    Algorithmic Visulization, Prof. George Legrady
    MAT 2015
*/







PeasyCam cam;
ControlP5 cp5;
PMatrix3D currCameraMatrix;
PGraphics3D g3; 

Table table_freq;
Table table_freq2;
Table table_deweys;

CheckBox checkbox;
CheckBox checkbox_labels;
CheckBox checkbox_label_flip;

int chartRadius = 440;
float innerCircleRadius = chartRadius*.33f;
int xPosition = 20;
int pos = 0;

int pickDataDate = 0;
int hoverTextSwitch = -1;

float marginX = 90;
float marginY = 40;

int [][] dataMatrix1 = null;
int [][] dataMatrix2 = null;
float [][] maxPerYear = new float[8][10];
float [] averages = new float[96];
float avgColorPick = 0;
int maxCount1, maxCount2;
int numRows1, numRows2, numColumns1, numColumns2, rowSpacing;

float [] cameraPos;
float user_rotate;
float user_separate = 1000;
int user_toggle_table1 = 1;
int user_toggle_table2 = 0;
int user_toggle_labels = 1;
int user_toggle_label_flip = 0;

String [] title_names1 = null;
String [] title_names2 = null;
String [] deweyNames = new String[20];

PFont fontHeader = createFont("SukhumvitSet-SemiBold", 30, true);
PFont fontHeader2 = createFont("SourceSansPro-Semibold", 14, true);
PFont fontYear = createFont("AvenirNext-UltraLightItalic", 48, true);
PFont fontSliders = createFont("AvenirNext-UltraLight", 10, true);
PFont fontLabelTitle = createFont("AvenirNext-UltraLight", 12, true);
PFont fontMain = createFont("SourceSansPro-Semibold", 22, true);
PFont fontSubtitle = createFont("Avenir-Regular", 11, true);

int bgColor = color(222,221,217);
int textColor = color(84, 81, 109);
int tickColor = color(151,151,184);
int colorHighlight = color(114,162,252);
int [] colorMap = {0xff98F487,0xff86ED8C,0xff74E591,0xff62DD95,0xff52D599,0xff42CD9C,0xff32C49E,0xff23BC9F,0xff14B3A0,0xff09AAA0,0xff06A19F,0xff0E989D,0xff18909A,0xff218796,0xff297E91,0xff30758B,0xff356C84,0xff39637D,0xff3D5B75,0xff3F526D};
int [] colorMapDark = {0xff0F200C,0xff0D200E,0xff0B2010,0xff082012,0xff062114,0xff042116,0xff032118,0xff02211A,0xff01211C,0xff01211E,0xff01201F,0xff012021,0xff022022,0xff032024,0xff051F25,0xff071F26,0xff0A1E27,0xff0D1E27,0xff101D28,0xff131D28};

float spare_slider = 0;
float spare_slider2 = 0;
float spare_slider3 = 0;
float spare_slider4 = 0;
Slider abc;
public void drawGUI() {

    currCameraMatrix = new PMatrix3D(g3.camera);
    camera();
    cp5.draw(); //DRAW CONTROLS AFTER CAMERA FOR GREAT SUCCESS
    g3.camera = currCameraMatrix;

    // TITLE
    fill(textColor);
    textFont(fontHeader);
    textAlign(LEFT);
    text("Into The Wild", marginX, marginY + 40);
    
    textFont(fontHeader2);
    text("Comparing Seattle's Interests in Fiction and Non-fiction", 
          marginX, marginY + 58);

    // LABELS
    textFont(fontLabelTitle);
    text("MOST CHECKED OUT TITLES", marginX, marginY+130);
    textFont(fontSliders);
    text("ENTIRE LIBRARY", marginX+25, marginY+154);
    text("WITHIN DEWEY", marginX+25, marginY+175);
    text("FLIP LABELS", marginX+25, marginY+259);
    text("TOGGLE LABELS", marginX+25, marginY+279);
    text("* One block = one week", marginX, marginY+680);

    // LEGEND
    if (user_toggle_labels == 1) {
        noStroke();
        pushMatrix();
            translate(marginX, marginY + 350);
            text("TOP DEWEY CLASSES", 0, -10);
            for (int i = 0; i < numColumns1; i++){
                fill(colorMap[i]);
                rect(0, i*15, 25, 12);
                fill(textColor);
                text(deweyNames[i], 30, (i*15)+10);
            }
        popMatrix();
    }

}

public void setupGUI() {

  ///////// Sliders /////////////////////////////////////////////////////

  cp5 = new ControlP5(this); 
  cp5.setControlFont(fontSliders);
  cp5.setColorLabel(textColor);

    cp5.addSlider("spare")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+40)
    .setSize(200, 30)
    .setRange(1.f, 500.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(210)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;

    cp5.addSlider("spare2")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+80)
    .setSize(200, 30)
    .setRange(-0.f, 500.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(160)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;

    cp5.addSlider("spare3")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+120)
    .setSize(200, 30)
    .setRange(0, 600.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(200)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;

    cp5.addSlider("spare4")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+160)
    .setSize(200, 30)
    .setRange(100.f, 800.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(600)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;
    cp5.addSlider("rotate")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(marginX, marginY+190)
    .setSize(170, 20)
    .setRange(-360.f, 360.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(0)
    .setSliderMode(Slider.FLEXIBLE)
    .setColorBackground(bgColor);
    ;
    
    cp5.addSlider("separate")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(marginX, marginY+220)
    .setSize(170, 20)
    .setRange(-2000.f, 2000.f)
    .setValue(1000)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setSliderMode(Slider.FLEXIBLE)
    .setColorBackground(bgColor);
    ;

    checkbox = cp5.addCheckBox("checkBox")
    .setPosition(marginX, marginY+145)
    .setColorForeground(textColor)
    .setColorBackground(tickColor)
    .setColorActive(colorHighlight)
    .setSize(12, 12)
    .setItemsPerRow(1)
    .setSpacingRow(8)
    .addItem("0", 1)
    .addItem("1", 0)
    .activate(0)
    .hideLabels()
    ;

    checkbox_label_flip = cp5.addCheckBox("checkbox_label_flip")
    .setPosition(marginX, marginY+250)
    .setColorForeground(textColor)
    .setColorBackground(tickColor)
    .setColorActive(colorHighlight)
    .setSize(12, 12)
    .setItemsPerRow(1)
    .setSpacingRow(0)
    .addItem("flip_labels_toggle", 1)
    .activate(0)
    .hideLabels()
    ;

    checkbox_labels = cp5.addCheckBox("checkbox_labels")
    .setPosition(marginX, marginY+270)
    .setColorForeground(textColor)
    .setColorBackground(tickColor)
    .setColorActive(colorHighlight)
    .setSize(12, 12)
    .setItemsPerRow(1)
    .setSpacingRow(0)
    .addItem("label_toggle", 1)
    .activate(0)
    .hideLabels()
    ;

    cp5.setAutoDraw(false);

}

public void controlEvent(ControlEvent theEvent) {

  if (theEvent.isFrom(cp5.getController("spare"))) {
    spare_slider = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("spare2"))) {
    spare_slider2 = theEvent.getController().getValue();
  }
    if (theEvent.isFrom(cp5.getController("spare3"))) {
    spare_slider3 = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("spare4"))) {
    spare_slider4 = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("rotate"))) {
    user_rotate = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("separate"))) {
    user_separate = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(checkbox)) {
      user_toggle_table1 = (int)checkbox.getArrayValue()[0];
      user_toggle_table2 = (int)checkbox.getArrayValue()[1];
    }
 if (theEvent.isFrom(checkbox_labels)) {
      user_toggle_labels = (int)checkbox_labels.getArrayValue()[0];
    }
 if (theEvent.isFrom(checkbox_label_flip)) {
      user_toggle_label_flip = (int)checkbox_label_flip.getArrayValue()[0];
    }
}
public void draw()
{
  background(bgColor);
  cameraPos = cam.getPosition();
  translate( -width/2, -height/4);   // Peasycam intially sets lookAt() at (0,0,0) hence we need to translate the axis

  // TURNS OFF CAMERA CONTROLS WHEN HOVERING OVER SLIDER
  if (cp5.window(this).isMouseOver()) {
    cam.setActive(false);
  } 
  else { 
    cam.setActive(true);
  }

  if (user_toggle_table1 == 1 && user_toggle_table2 == 1){
    drawData(dataMatrix1, numRows1, numColumns1, maxCount1, 0, 0, title_names1);
    drawData(dataMatrix2, numRows2, numColumns2, maxCount1, (int)user_separate, 2, title_names2);
  } 
  else if (user_toggle_table1 == 1) {
    drawData(dataMatrix1, numRows1, numColumns1, maxCount1, 0, 0, title_names1);
  }
  else if (user_toggle_table2 == 1) {
    drawData(dataMatrix2, numRows2, numColumns2, maxCount2, (int)user_separate, 2, title_names2);
  }

  drawGUI();

}
public void drawData(int[][] _inputArray, int _numRows, int _numColumns, int _maxCount, 
              int _z_offset, int _y_offset, String[] _title_names)
{
  pushMatrix();
  translate(350,1200,100);
  translate(_z_offset, _y_offset, 0);
  rotate(radians(-90),0,0,1);
  rotate(radians(-user_rotate-50),1,0,0);

  noStroke();

  ///////////////////////////////////////////////////////////////////////
  ///////// Draw Geometry ///////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////
  for (int i = 0; i < _numColumns; i++) {
    
    pushMatrix();
    
    rotate((i/(float)_numColumns) * PI * -1.95f, 1, 0, 0);

    for (int j = 0; j < _numRows-1; j++) {        // j=1 less than max to fix "fillColor2" quad drawing logic

      colorMode(HSB);

      float fillColor = (255 * _inputArray[j][i] / (float)_maxCount);
      float fillColor2 = (255 * _inputArray[j+1][i] / (float)_maxCount);

      float heightVal = _inputArray[j][i] / (float)_maxCount ;
      float heightVal2 = _inputArray[j+1][i] / (float)_maxCount  ;

      float y_offset = -80;
      float y_mult = -250;
      float x1 = j*10;
      float x2 = (j+1)*10;
      float y1 = (heightVal*y_mult) + y_offset;
      float y2 = (heightVal2*y_mult) + y_offset;
      float z_flat = 8;
      float z_slope = 4;
      float z_peak = 14;

      pushMatrix();
      translate(0,0,-19);  //fixes rotation overlaps; z=total strip width/2
      
      beginShape(QUAD_STRIP);

        stroke(0, 60);
        strokeWeight(1);
        fill(colorMapDark[i], fillColor*255);
        vertex(x1,y_offset,0);
        vertex(x2,y_offset,0);
        vertex(x1,y_offset,z_flat);
        vertex(x2,y_offset,z_flat);
        fill(colorMap[i], fillColor*255);
        vertex(x1,y1,z_flat+z_slope);
        vertex(x2,y2,z_flat+z_slope);
        vertex(x1,y1,z_flat+z_slope+z_peak);
        vertex(x2,y2,z_flat+z_slope+z_peak);
        fill(colorMapDark[i], fillColor*255);
        vertex(x1,y_offset,z_flat+z_slope+z_peak+z_slope);
        vertex(x2,y_offset,z_flat+z_slope+z_peak+z_slope);
        vertex(x1,y_offset,z_flat+z_slope+z_peak+z_slope+z_flat);
        vertex(x2,y_offset,z_flat+z_slope+z_peak+z_slope+z_flat);

      endShape();
      popMatrix();

      colorMode(RGB);

    }
    popMatrix();
  }
  
  ///////////////////////////////////////////////////////////////////////
  ///////// Draw Labels /////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////  
  drawLabels(_inputArray, _numRows, _numColumns, _title_names);

  popMatrix();


}

public void drawLabels(int[][] _labelArray, int _numRows, int _numColumns, String[] _title_names) {
  for (int i = 0; i < 6; i++){

    // CIRCLES
    pushMatrix();
      rotate(radians(90), 0, 1, 0);
      translate(0, 0, i * (_numRows-1)*2);
      noFill();
      strokeWeight(2);
      stroke(5,100);
      ellipse(0, 0, 575, 575);

      // YEARS
      textFont(fontYear);  
      fill(5,200);  
      pushMatrix();
        rotate(radians(-90), 1, 0, 0);
        rotate(radians(-160 - user_rotate),0,1,0);
        String year_step = nf(i+8, 2);
        text("20"+year_step, 300, -10, 0);
        // text(fade, 210, 15, 0);
      popMatrix();
    
      // BOOK TITLES  
      if (user_toggle_labels == 1) {
        float heightCalc = (i + 900) - (580 * i);
        float fade = abs(cameraPos[1] - heightCalc) * .3f;
        float fade_lines = fade;
        if (fade_lines <= 120) fade_lines = 120;

        textFont(fontMain);
        fill(50, 255-(int)fade);
        strokeWeight(1);

        for (int j = 0; j < _numColumns; j++){
          pushMatrix();
          rotate(((j+5)/(float)_numColumns) * -PI * 2 + .03f, 0, 0, 1);
          stroke(5, 255-(int)fade_lines);
          line(85, 0, 0, 270, 0, 0);
          
          if (user_toggle_label_flip == 1) {
            rotate(radians(180), 1, 0, 0);
            text(_title_names[j], 300, 6, 0);
          } else {
            text(_title_names[j], 300, 6, 0);
          }

          popMatrix();
        }
      }
    popMatrix();
  }
}
public void setup()
{
  size(1280,800,OPENGL);
 
  
  if (frame != null) {
    frame.setResizable(true);
  }
  
  //setting up the camera
  cam= new PeasyCam( this,0,0,100,2200);       
  cam.setMinimumDistance(20);
  cam.setMaximumDistance(4000);
  cam.setSuppressRollRotationMode();
  cameraPos = cam.getPosition();

  //control P5 stuff      
  cp5 = new ControlP5(this);
  g3 = (PGraphics3D)g;
  setupGUI();

  rowSpacing = 54;
  table_freq = loadTable("top_checkout_freq.csv");
  numRows1 = table_freq.getRowCount() - 1;
  numColumns1 = table_freq.getColumnCount() - 2;
  dataMatrix1 = new int[numRows1][numColumns1];
  maxCount1 = dataMatrix1[0][0];
  title_names1 = new String[numColumns1];

  table_freq2 = loadTable("top_checkout_freq_dewey.csv");
  numRows2 = table_freq2.getRowCount() - 1;
  numColumns2 = table_freq2.getColumnCount() - 2;
  dataMatrix2 = new int[numRows2][numColumns2];
  maxCount2 = dataMatrix2[0][0];
  title_names2 = new String[numColumns2];

  table_deweys = loadTable("top_titles_with_deweys.csv");


  ///////////////////////////////////////////////////////////////////////
  ///////// Load arrays with data ///////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////

  for (int i = 0; i < numRows1; i++) {
    for (int j = 0; j < numColumns1; j++) {//skipping two columns j=2 
      dataMatrix1[i][j] = table_freq.getInt(i+1, j+2);
      if (dataMatrix1[i][j] > maxCount1)
        maxCount1 = dataMatrix1[i][j];
    }
  }
  for (int i = 0; i < numColumns1; i++) {
    title_names1[i] = table_freq.getString(0,i+2);
  }
  println("Rows: " + numRows1 + ", Columns: " + numColumns1 + ", max: " + maxCount1);
  println();
  println();

  // TABLE # 2
  for (int i = 0; i < numRows2; i++) {
    for (int j = 0; j < numColumns2; j++) { //skipping two columns j=2
      dataMatrix2[i][j] = table_freq2.getInt(i+1, j+2);
      if (dataMatrix2[i][j] > maxCount2)
        maxCount2 = dataMatrix2[i][j];
    }
  }
  for (int i = 0; i < numColumns2; i++) {
    title_names2[i] = table_freq2.getString(0,i+2);
  }

  for (int i = 0; i < 20; i++) {
    deweyNames[i] = table_deweys.getString(i+2, 0)  + " - " + table_deweys.getString(i+2,4);
    println(deweyNames[i]);

  }

 
  background(bgColor);
  noStroke();
  
  println("setup done");

  /*%%%%%% End Setup %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "hw3_3d" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
