void drawGUI() {

    currCameraMatrix = new PMatrix3D(g3.camera);
    camera();
    cp5.draw(); //DRAW CONTROLS AFTER CAMERA FOR GREAT SUCCESS
    g3.camera = currCameraMatrix;

    // TITLE
    fill(textColor);
    textFont(fontHeader);
    textAlign(LEFT);
    text("Into The Wild", marginX, marginY + 40);
    
    textFont(fontHeader2);
    text("Comparing Seattle's Interests in Fiction and Non-fiction", 
          marginX, marginY + 58);

    // LABELS
    textFont(fontLabelTitle);
    text("MOST CHECKED OUT TITLES", marginX, marginY+130);
    textFont(fontSliders);
    text("ENTIRE LIBRARY", marginX+25, marginY+154);
    text("WITHIN DEWEY", marginX+25, marginY+175);
    text("FLIP LABELS", marginX+25, marginY+259);
    text("TOGGLE LABELS", marginX+25, marginY+279);
    text("* One block = one week", marginX, marginY+680);

    // LEGEND
    if (user_toggle_labels == 1) {
        noStroke();
        pushMatrix();
            translate(marginX, marginY + 350);
            text("TOP DEWEY CLASSES", 0, -10);
            for (int i = 0; i < numColumns1; i++){
                fill(colorMap[i]);
                rect(0, i*15, 25, 12);
                fill(textColor);
                text(deweyNames[i], 30, (i*15)+10);
            }
        popMatrix();
    }

}

void setupGUI() {

  ///////// Sliders /////////////////////////////////////////////////////

  cp5 = new ControlP5(this); 
  cp5.setControlFont(fontSliders);
  cp5.setColorLabel(textColor);

    cp5.addSlider("spare")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+40)
    .setSize(200, 30)
    .setRange(1.f, 500.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(210)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;

    cp5.addSlider("spare2")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+80)
    .setSize(200, 30)
    .setRange(-0.f, 500.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(160)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;

    cp5.addSlider("spare3")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+120)
    .setSize(200, 30)
    .setRange(0, 600.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(200)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;

    cp5.addSlider("spare4")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(width-marginX*5, marginY+160)
    .setSize(200, 30)
    .setRange(100.f, 800.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(600)
    .setSliderMode(Slider.FLEXIBLE)
    .setVisible(false)
    .setColorBackground(bgColor);
    ;
    cp5.addSlider("rotate")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(marginX, marginY+190)
    .setSize(170, 20)
    .setRange(-360.f, 360.f)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setValue(0)
    .setSliderMode(Slider.FLEXIBLE)
    .setColorBackground(bgColor);
    ;
    
    cp5.addSlider("separate")
    // .setPosition(width-(marginX*6), marginY*1.5)
    .setPosition(marginX, marginY+220)
    .setSize(170, 20)
    .setRange(-2000.f, 2000.f)
    .setValue(1000)
    .setColorValueLabel(textColor)
    .setColorForeground(tickColor)
    .setColorTickMark(tickColor)  
    .setColorActive(colorHighlight)      
    .setSliderMode(Slider.FLEXIBLE)
    .setColorBackground(bgColor);
    ;

    checkbox = cp5.addCheckBox("checkBox")
    .setPosition(marginX, marginY+145)
    .setColorForeground(textColor)
    .setColorBackground(tickColor)
    .setColorActive(colorHighlight)
    .setSize(12, 12)
    .setItemsPerRow(1)
    .setSpacingRow(8)
    .addItem("0", 1)
    .addItem("1", 0)
    .activate(0)
    .hideLabels()
    ;

    checkbox_label_flip = cp5.addCheckBox("checkbox_label_flip")
    .setPosition(marginX, marginY+250)
    .setColorForeground(textColor)
    .setColorBackground(tickColor)
    .setColorActive(colorHighlight)
    .setSize(12, 12)
    .setItemsPerRow(1)
    .setSpacingRow(0)
    .addItem("flip_labels_toggle", 1)
    .activate(0)
    .hideLabels()
    ;

    checkbox_labels = cp5.addCheckBox("checkbox_labels")
    .setPosition(marginX, marginY+270)
    .setColorForeground(textColor)
    .setColorBackground(tickColor)
    .setColorActive(colorHighlight)
    .setSize(12, 12)
    .setItemsPerRow(1)
    .setSpacingRow(0)
    .addItem("label_toggle", 1)
    .activate(0)
    .hideLabels()
    ;

    cp5.setAutoDraw(false);

}

void controlEvent(ControlEvent theEvent) {

  if (theEvent.isFrom(cp5.getController("spare"))) {
    spare_slider = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("spare2"))) {
    spare_slider2 = theEvent.getController().getValue();
  }
    if (theEvent.isFrom(cp5.getController("spare3"))) {
    spare_slider3 = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("spare4"))) {
    spare_slider4 = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("rotate"))) {
    user_rotate = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(cp5.getController("separate"))) {
    user_separate = theEvent.getController().getValue();
  }
  if (theEvent.isFrom(checkbox)) {
      user_toggle_table1 = (int)checkbox.getArrayValue()[0];
      user_toggle_table2 = (int)checkbox.getArrayValue()[1];
    }
 if (theEvent.isFrom(checkbox_labels)) {
      user_toggle_labels = (int)checkbox_labels.getArrayValue()[0];
    }
 if (theEvent.isFrom(checkbox_label_flip)) {
      user_toggle_label_flip = (int)checkbox_label_flip.getArrayValue()[0];
    }
}