void drawData(int[][] _inputArray, int _numRows, int _numColumns, int _maxCount, 
              int _z_offset, int _y_offset, String[] _title_names)
{
  pushMatrix();
  translate(350,1200,100);
  translate(_z_offset, _y_offset, 0);
  rotate(radians(-90),0,0,1);
  rotate(radians(-user_rotate-50),1,0,0);

  noStroke();

  ///////////////////////////////////////////////////////////////////////
  ///////// Draw Geometry ///////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////
  for (int i = 0; i < _numColumns; i++) {
    
    pushMatrix();
    
    rotate((i/(float)_numColumns) * PI * -1.95, 1, 0, 0);

    for (int j = 0; j < _numRows-1; j++) {        // j=1 less than max to fix "fillColor2" quad drawing logic

      colorMode(HSB);

      float fillColor = (255 * _inputArray[j][i] / (float)_maxCount);
      float fillColor2 = (255 * _inputArray[j+1][i] / (float)_maxCount);

      float heightVal = _inputArray[j][i] / (float)_maxCount ;
      float heightVal2 = _inputArray[j+1][i] / (float)_maxCount  ;

      float y_offset = -80;
      float y_mult = -250;
      float x1 = j*10;
      float x2 = (j+1)*10;
      float y1 = (heightVal*y_mult) + y_offset;
      float y2 = (heightVal2*y_mult) + y_offset;
      float z_flat = 8;
      float z_slope = 4;
      float z_peak = 14;

      pushMatrix();
      translate(0,0,-19);  //fixes rotation overlaps; z=total strip width/2
      
      beginShape(QUAD_STRIP);

        stroke(0, 60);
        strokeWeight(1);
        fill(colorMapDark[i], fillColor*255);
        vertex(x1,y_offset,0);
        vertex(x2,y_offset,0);
        vertex(x1,y_offset,z_flat);
        vertex(x2,y_offset,z_flat);
        fill(colorMap[i], fillColor*255);
        vertex(x1,y1,z_flat+z_slope);
        vertex(x2,y2,z_flat+z_slope);
        vertex(x1,y1,z_flat+z_slope+z_peak);
        vertex(x2,y2,z_flat+z_slope+z_peak);
        fill(colorMapDark[i], fillColor*255);
        vertex(x1,y_offset,z_flat+z_slope+z_peak+z_slope);
        vertex(x2,y_offset,z_flat+z_slope+z_peak+z_slope);
        vertex(x1,y_offset,z_flat+z_slope+z_peak+z_slope+z_flat);
        vertex(x2,y_offset,z_flat+z_slope+z_peak+z_slope+z_flat);

      endShape();
      popMatrix();

      colorMode(RGB);

    }
    popMatrix();
  }
  
  ///////////////////////////////////////////////////////////////////////
  ///////// Draw Labels /////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////  
  drawLabels(_inputArray, _numRows, _numColumns, _title_names);

  popMatrix();


}

