void setup()
{
  size(1280,800,OPENGL);
 
  
  if (frame != null) {
    frame.setResizable(true);
  }
  
  //setting up the camera
  cam= new PeasyCam( this,0,0,100,2200);       
  cam.setMinimumDistance(20);
  cam.setMaximumDistance(4000);
  cam.setSuppressRollRotationMode();
  cameraPos = cam.getPosition();

  //control P5 stuff      
  cp5 = new ControlP5(this);
  g3 = (PGraphics3D)g;
  setupGUI();

  rowSpacing = 54;
  table_freq = loadTable("top_checkout_freq.csv");
  numRows1 = table_freq.getRowCount() - 1;
  numColumns1 = table_freq.getColumnCount() - 2;
  dataMatrix1 = new int[numRows1][numColumns1];
  maxCount1 = dataMatrix1[0][0];
  title_names1 = new String[numColumns1];

  table_freq2 = loadTable("top_checkout_freq_dewey.csv");
  numRows2 = table_freq2.getRowCount() - 1;
  numColumns2 = table_freq2.getColumnCount() - 2;
  dataMatrix2 = new int[numRows2][numColumns2];
  maxCount2 = dataMatrix2[0][0];
  title_names2 = new String[numColumns2];

  table_deweys = loadTable("top_titles_with_deweys.csv");


  ///////////////////////////////////////////////////////////////////////
  ///////// Load arrays with data ///////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////

  for (int i = 0; i < numRows1; i++) {
    for (int j = 0; j < numColumns1; j++) {//skipping two columns j=2 
      dataMatrix1[i][j] = table_freq.getInt(i+1, j+2);
      if (dataMatrix1[i][j] > maxCount1)
        maxCount1 = dataMatrix1[i][j];
    }
  }
  for (int i = 0; i < numColumns1; i++) {
    title_names1[i] = table_freq.getString(0,i+2);
  }
  println("Rows: " + numRows1 + ", Columns: " + numColumns1 + ", max: " + maxCount1);
  println();
  println();

  // TABLE # 2
  for (int i = 0; i < numRows2; i++) {
    for (int j = 0; j < numColumns2; j++) { //skipping two columns j=2
      dataMatrix2[i][j] = table_freq2.getInt(i+1, j+2);
      if (dataMatrix2[i][j] > maxCount2)
        maxCount2 = dataMatrix2[i][j];
    }
  }
  for (int i = 0; i < numColumns2; i++) {
    title_names2[i] = table_freq2.getString(0,i+2);
  }

  for (int i = 0; i < 20; i++) {
    deweyNames[i] = table_deweys.getString(i+2, 0)  + " - " + table_deweys.getString(i+2,4);
    println(deweyNames[i]);

  }

 
  background(bgColor);
  noStroke();
  
  println("setup done");

  /*%%%%%% End Setup %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
}
